<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        
        
        
        <link rel="shortcut icon" href="img/favicon.ico">
        <title>Importing - PM4Py-mongo Documentation</title>
        <link href="css/bootstrap-custom.min.css" rel="stylesheet">
        <link href="css/font-awesome.min.css" rel="stylesheet">
        <link href="css/base.css" rel="stylesheet">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css">
        <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
        <!--[if lt IE 9]>
            <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
            <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
        <![endif]-->

        <script src="js/jquery-1.10.2.min.js" defer></script>
        <script src="js/bootstrap-3.0.3.min.js" defer></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
        <script>hljs.initHighlightingOnLoad();</script> 
    </head>

    <body>

        <div class="navbar navbar-default navbar-fixed-top" role="navigation">
            <div class="container">

                <!-- Collapsed navigation -->
                <div class="navbar-header">
                    <!-- Expander button -->
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="sr-only">Toggle navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand" href="index.html">PM4Py-mongo Documentation</a>
                </div>

                <!-- Expanded navigation -->
                <div class="navbar-collapse collapse">
                        <!-- Main navigation -->
                        <ul class="nav navbar-nav">
                            <li >
                                <a href="index.html">Start</a>
                            </li>
                            <li class="active">
                                <a href="import.html">Importing</a>
                            </li>
                            <li >
                                <a href="filter.html">Filtering</a>
                            </li>
                            <li >
                                <a href="dfg.html">DFG Calculation</a>
                            </li>
                        </ul>

                    <ul class="nav navbar-nav navbar-right">
                        <li>
                            <a href="#" data-toggle="modal" data-target="#mkdocs_search_modal">
                                <i class="fa fa-search"></i> Search
                            </a>
                        </li>
                            <li >
                                <a rel="next" href="index.html">
                                    <i class="fa fa-arrow-left"></i> Previous
                                </a>
                            </li>
                            <li >
                                <a rel="prev" href="filter.html">
                                    Next <i class="fa fa-arrow-right"></i>
                                </a>
                            </li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="container">
                <div class="col-md-3"><div class="bs-sidebar hidden-print affix well" role="complementary">
    <ul class="nav bs-sidenav">
        <li class="main active"><a href="#importing">Importing</a></li>
            <li><a href="#csv-format">CSV Format</a></li>
            <li><a href="#create_from_csv">create_from_csv()</a></li>
            <li><a href="#insert_from_csv">insert_from_csv()</a></li>
    </ul>
</div></div>
                <div class="col-md-9" role="main">

<h1 id="importing">Importing</h1>
<p>This page documents the <em>importer</em> component of the library. The component is used to import an event log that is contained in some kind of file into the database. Currently the importer is able to import events contained in a given CSV file. Requirements for the formatting of the file can be found below. Events can either be inserted into a new database, or added to an existing one. </p>
<p>All of the functions require a running MongoDB instance.</p>
<hr />
<h2 id="csv-format">CSV Format</h2>
<p>The following properties must be fulfilled by the CSV document to enable a successfull import by the importer.</p>
<ul>
<li>The file has to be <code>utf-8</code> encoded.</li>
<li>Any <code>delimiter</code> can be used, delimiters other than <code>,</code> must be specified during import.</li>
<li>The default <code>quotechar</code> <code>"</code> is used for special values.</li>
<li>The first line of the file contains the column names.</li>
<li>The column containing the <em>case identifier</em> is called <code>case:concept:name</code></li>
<li>The column containing the <em>activity name</em> is called <code>concept:name</code></li>
<li>The column containing the <em>timestamp</em> of the event is called <code>time:timestamp</code>.</li>
<li>All times and dates are following the format <code>%Y-%m-%d %H:%M:%S</code>.</li>
</ul>
<hr />
<h2 id="create_from_csv"><code>create_from_csv()</code></h2>
<h3 id="description">Description</h3>
<p>Creates a new database with the given name using the given MongoDB client instance. The events contained in the CSV file located at the given filepath will be inserted into the <code>eventData</code> collection of the newly created database.</p>
<h3 id="input">Input</h3>
<ul>
<li><code>name</code> - String<ul>
<li>The name that should be given to the newly created database.</li>
</ul>
</li>
<li><code>filepath</code> - String<ul>
<li>The path pointing to the file that should be imported.</li>
</ul>
</li>
<li><code>delimiter</code> <em>(optional)</em> - String<ul>
<li>The character that is used as a seperator for the columns of the CSV. The default value is <code>,</code>.</li>
</ul>
</li>
<li><code>batchsize</code> <em>(optional)</em> - Integer<ul>
<li>Indicates how many events are inserted into the database at the same time. The default value is <code>0</code> indicating that all events are added at the same time. See notes for more details.</li>
</ul>
</li>
<li><code>client</code> <em>(optional)</em> - MongoClient<ul>
<li>The MongoDB instance that should be used. When no client is specified, the default client <code>MongoClient()</code> <em>(host='localhost', port=27017)</em> will be used.</li>
</ul>
</li>
</ul>
<h3 id="output">Output</h3>
<p>The newly created database.</p>
<h3 id="notes">Notes</h3>
<p>The ideal batch size is a combination of memory and performance concerns. A large batch size equals a large memory consumption. If the batch size is chosen too small, the import will be slow. For the best performance, the batch size should be chosen based on the dataset that is to be imported.</p>
<hr />
<h2 id="insert_from_csv"><code>insert_from_csv()</code></h2>
<h3 id="description_1">Description</h3>
<p>Inserts the events contained in the CSV file located at the given filepath into an existing database into the <code>eventData</code> collection.</p>
<h3 id="input_1">Input</h3>
<ul>
<li><code>database</code> - Database<ul>
<li>The existing database in which the events should be inserted.</li>
</ul>
</li>
<li><code>filepath</code> - String<ul>
<li>The path pointing to the file that should be imported.</li>
</ul>
</li>
<li><code>delimiter</code> <em>(optional)</em> - String<ul>
<li>The character that is used as a seperator for the columns of the CSV. The default value is <code>"</code>.</li>
</ul>
</li>
<li><code>batchsize</code> <em>(optional)</em> - Integer<ul>
<li>Indicates how many events are inserted into the database at the same time. The default value is <code>0</code> indicating that all events are added at the same time. See notes for more details.</li>
</ul>
</li>
<li><code>client</code> <em>(optional)</em> - MongoClient<ul>
<li>The MongoDB instance that should be used. When no client is specified, the default client <code>MongoClient()</code> <em>(host='localhost', port=27017)</em> will be used.</li>
</ul>
</li>
</ul>
<h3 id="output_1">Output</h3>
<p>The given database. (Containing the new events.)</p>
<h3 id="notes_1">Notes</h3>
<p>The ideal batch size is a combination of memory and performance concerns. A large batch size equals a large memory consumption. If the batch size is chosen too small, the import will be slow. For the best performance, the batch size should be chosen based on the dataset that is to be imported.</p>
<hr /></div>
        </div>

        <footer class="col-md-12">
            <hr>
            <p>Documentation built with <a href="https://www.mkdocs.org/">MkDocs</a>.</p>
        </footer>
        <script>
            var base_url = ".",
                shortcuts = {"help": 191, "next": 78, "previous": 80, "search": 83};
        </script>
        <script src="js/base.js" defer></script>
        <script src="search/main.js" defer></script>

        <div class="modal" id="mkdocs_search_modal" tabindex="-1" role="dialog" aria-labelledby="Search Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Search</h4>
            </div>
            <div class="modal-body">
                <p>
                    From here you can search these documents. Enter
                    your search terms below.
                </p>
                <form role="form">
                    <div class="form-group">
                        <input type="text" class="form-control" placeholder="Search..." id="mkdocs-search-query" title="Type search term here">
                    </div>
                </form>
                <div id="mkdocs-search-results"></div>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div><div class="modal" id="mkdocs_keyboard_modal" tabindex="-1" role="dialog" aria-labelledby="Keyboard Shortcuts Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Keyboard Shortcuts</h4>
            </div>
            <div class="modal-body">
              <table class="table">
                <thead>
                  <tr>
                    <th style="width: 20%;">Keys</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td class="help shortcut"><kbd>?</kbd></td>
                    <td>Open this help</td>
                  </tr>
                  <tr>
                    <td class="next shortcut"><kbd>n</kbd></td>
                    <td>Next page</td>
                  </tr>
                  <tr>
                    <td class="prev shortcut"><kbd>p</kbd></td>
                    <td>Previous page</td>
                  </tr>
                  <tr>
                    <td class="search shortcut"><kbd>s</kbd></td>
                    <td>Search</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div>

    </body>
</html>
